﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using System.Text.RegularExpressions;
using System.Net;
using System.Reflection;

namespace XTX.parser
{
    public partial class Engine
    {
        private XmlNode node;

        public delegate object fun(XmlNode e);

        private Dictionary<string, fun> handleMap = new Dictionary<string, fun>();
        //private Dictionary<Pare<Type,Type>, Func<object, object>> translateMap = new Dictionary<Type, Func<object, object>>();

        private string input_string;

        private void initHandleMap()
        {
            add_object_handleMap(this);
        }

        public void add_object_handleMap(object o)
        {
            foreach (MethodInfo f in o.GetType().GetMethods(BindingFlags.NonPublic | BindingFlags.Instance | BindingFlags.Public))
            {
                foreach (RegisterActionAttribute a in f.GetCustomAttributes(typeof(RegisterActionAttribute),false))
                {
                    string name = a.Name == null ? f.Name : a.Name;
                    handleMap.Add(name, (fun)Delegate.CreateDelegate(typeof(fun), o, f));
                }
            }
        }

        public Engine(XmlNode node)
        {
            if (node == null)
                throw new ArgumentNullException();
            this.node = node;
            initHandleMap();
        }

        public string transform(string x)
        {
            input_string = x;
            try
            {
                return cast<string>(handle(node));
            }
            finally
            {
                input_string = null;
            }
        }

        public string transform()
        {
            return cast<string>(handle(node));
        }
    }

    public class ParserException : Exception
    {
        public ParserException() { }

        public ParserException(string s)
            : base(s) { }
    }
}
