﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Xml;
using System.Text.RegularExpressions;
using System.Net;

namespace XTX.parser
{
    public partial class Engine
    {

        private object handle(XmlNode e)
        {
            return warn_null(handleMap[e.Name](e));
        }

        private string to_string(object o)
        {
            if (o is string)
                return (string)o;
            if (o is Match || o is Group)
                return o.ToString();
            throw new Exception("Can not cast `" + o.GetType().ToString() + "` to `System.String`");
        }

        private XmlNode xmlFirstChild(XmlNode e)
        {
            foreach (XmlNode i in e)
                if (!skipNode(i))
                    return i;
            return null;
        }

        private XmlNode extractParam(XmlNode e, string n)
        {
            return xmlFirstChild(e.SelectSingleNode(n));
        }

        private bool extractBoolAttribute(XmlNode e, string n, bool def)
        {
            XmlAttribute a = e.Attributes[n];
            if (a == null)
                return def;
            else
                return a.Value == "true" || a.Value == "1";
        }

        private object warn_null(object e)
        {
            if (e == null)
                throw new Exception("Operation return no result");
            return e;
        }

        private bool skipNode(XmlNode e)
        {
            return e.NodeType == XmlNodeType.Comment;
        }

        private T cast<T>(object o)
        {
            if(typeof(T) == typeof(string))
                return (T)(object)to_string(o);
            return (T)o;
        }
    }
}